# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import gtk
from gtk import glade

import time
import datetime as DT
import StringIO
import locale

import rpc
import tools
import tools.datetime_util

from widget.view import interface

DT_FORMAT = '%Y-%m-%d'
DHM_FORMAT = '%Y-%m-%d %H:%M:%S'
HM_FORMAT = '%H:%M:%S'
LDFMT = tools.datetime_util.get_date_format()


import sys
import optparse

import xmlrpclib


class ViewMDX(object):
    def __init__(self, model, axis, fields, axis_data={}, attrs={}):
        print "\n\n ::::::::: call init of view mdx inside:::::"
        self.widget = gtk.VBox(False,2)
        self.tbl=gtk.Table()
        self.widget.editable = False


    def display(self, model_id):
        print "\n ::::::::call display of view mdx inside ;::"
        self.tbl.destroy()
        testing = rpc.session.rpc_exec_auth_try('/object', 'execute', 'olap.saved.query', 'read',model_id ,['query'])
        testing_new = rpc.session.rpc_exec_auth_try('/object', 'execute', 'olap.saved.query', 'read',model_id ,['schema_id'])
        sock = xmlrpclib.ServerProxy(rpc.session._url+'/object')
        axis,data = sock.execute(rpc.session.db, rpc.session.uid, rpc.session._passwd, 'olap.schema', 'request', testing_new['schema_id'][1], testing['query'])
        cntr=0
        print "\n\n ::::::::::::: axis ::::::::",axis
        print "\n :::::::::::::: data :::::",data
        name_row=[]
        name_col=[]
        row_len=len(axis[0])+1
        col_len=len(axis[1])+1
        vnbox=gtk.VBox(False,2)
        table = gtk.Table(row_len,col_len, True)
        table.attach(gtk.Label("  "), 0, 1, 1, 2)
        t1=2
        tp=0
        for i in axis[0]:
            p1=0
            lnspc=len(i[0])
            spc='     '
            spc=lnspc*spc
            lblnm=spc+i[1]
            lbl=gtk.Label(lblnm)
            lbl.set_alignment(False,0.5)
            lbl.set_markup("<sup><b><span foreground=\"darkred\">"+lblnm+"</span></b></sup>")
            table.attach(lbl,p1,p1+1,t1,t1+1)
            if type(i[0][-1]).__name__=='list' :
                p1=p1+1
                lblnew=gtk.Label(str(i[0][-1]))
                lblnew.set_alignment(False,0.5)
                lblnew.set_markup("<sup><b><span foreground=\"darkred\">"+str(i[0][-1])+"</span></b></sup>")
                table.attach(lblnew,p1,p1+1,t1,t1+1)
            tp=p1+1
            t1=t1+1

#            lnspc=len(i[0])
##            print "\n :::: lenspc :::",lnspc
#            temp='     '
#            temp=lnspc*temp
#            name_row.append(temp+i[1])
#        t1=2
##        print "\n :::: name_row :::",name_row
#        for i in name_row:
#            lbl=gtk.Label()
#            lbl.set_alignment(False,0.5)
#            lbl.set_markup("<sup><b><span foreground=\"darkred\">"+i+"</span></b></sup>")
##            lbl.set_markup("<sup><span background=\"white\">"+i+"</span></sup>")
##            table.attach(gtk.Label(i),0,1,t1,t1+1)
#            table.attach(lbl,0,1,t1,t1+1)
#            t1=t1+1
#
        for j in axis[1]:
            name_col.append(j[1])
        p1=tp
        for j in name_col:
            lbl=gtk.Label()
#            lbl.set_markup("<sup><span background=\"white\">"+j+"</span></sup>")
            lbl.set_markup("<sup><b><span foreground=\"darkred\">"+j+"</span></b></sup>")

            lbl.set_alignment(1,False)
            table.attach(lbl,p1,p1+1,1,2)
            p1=p1+1
#
        t1=2
        for i in data:
            p1=tp
            for j in i:
                lbl=gtk.Label(j[0])
                lbl.set_alignment(True,False)
                table.attach(lbl,p1,p1+1,t1,t1+1)
                p1=p1+1
            t1=t1+1
        self.tbl.add(table)
        self.widget.pack_start(self.tbl,False,False,0)
        table_new = gtk.Table(row_len,col_len, True)
        table_new.attach(gtk.Label("  "), 0, 1, 1, 2)


        try:
            self.widget.show_all()
        except:
            pass

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
